Index: pjproject/trunk/pjsip/build/pjsip_core.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 108)
+++ pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 109)
@@ -128,6 +128,4 @@
 !IF  "$(CFG)" == "pjsip_core - Win32 Release"
 
-# PROP Exclude_From_Build 1
-
 !ELSEIF  "$(CFG)" == "pjsip_core - Win32 Debug"
 
Index: pjproject/trunk/pjsip/build/test_pjsip.dsp
===================================================================
--- pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 108)
+++ pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 109)
@@ -94,4 +94,8 @@
 # Begin Source File
 
+SOURCE="..\src\test-pjsip\msg_logger.c"
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\test-pjsip\msg_test.c"
 # End Source File
@@ -111,4 +115,8 @@
 
 SOURCE="..\src\test-pjsip\transport_udp_test.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\test-pjsip\tsx_basic_test.c"
 # End Source File
 # Begin Source File
Index: pjproject/trunk/pjsip/include/pjsip/sip_errno.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 108)
+++ pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 109)
@@ -24,4 +24,9 @@
 PJ_BEGIN_DECL
 
+/**
+ * Guidelines on error message length.
+ */
+#define PJSIP_ERR_MSG_SIZE  64
+
 /*
  * PJSIP error codes occupies 170000 - 219000, and mapped as follows:
@@ -87,4 +92,9 @@
  */
 #define PJSIP_ETYPEEXISTS	(PJSIP_ERRNO_START_PJSIP + 2)	/* 171002 */
+/**
+ * @hideinitializer
+ * SIP stack is shutting down.
+ */
+#define PJSIP_ESHUTDOWN		(PJSIP_ERRNO_START_PJSIP + 3)	/* 171003 */
 
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_module.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_module.h	(revision 108)
+++ pjproject/trunk/pjsip/include/pjsip/sip_module.h	(revision 109)
@@ -134,4 +134,26 @@
 
     /**
+     * Called to process outgoing request.
+     *
+     * @param tdata	The outgoing request message.
+     *
+     * @return		Module should return PJ_SUCCESS in all cases. 
+     *			If non-zero (or PJ_FALSE) is returned, the message 
+     *			will not be sent.
+     */
+    pj_status_t (*on_tx_request)(pjsip_tx_data *tdata);
+
+    /**
+     * Called to process outgoing response message.
+     *
+     * @param tdata	The outgoing response message.
+     *
+     * @return		Module should return PJ_SUCCESS in all cases. 
+     *			If non-zero (or PJ_FALSE) is returned, the message 
+     *			will not be sent.
+     */
+    pj_status_t (*on_tx_response)(pjsip_tx_data *tdata);
+
+    /**
      * Called when this module is acting as transaction user for the specified
      * transaction, when the transaction's state has changed.
@@ -151,7 +173,8 @@
 enum pjsip_module_priority
 {
-    PJSIP_MOD_PRIORITY_TSX_LAYER = 4,
-    PJSIP_MOD_PRIORITY_UA_PROXY_LAYER = 16,
-    PJSIP_MOD_PRIORITY_APPLICATION = 32,
+    PJSIP_MOD_PRIORITY_TRANSPORT_LAYER	= 8,
+    PJSIP_MOD_PRIORITY_TSX_LAYER	= 16,
+    PJSIP_MOD_PRIORITY_UA_PROXY_LAYER	= 32,
+    PJSIP_MOD_PRIORITY_APPLICATION	= 64,
 };
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_msg.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 108)
+++ pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 109)
@@ -377,4 +377,5 @@
 
     PJSIP_SC_OK = 200,
+    PJSIP_SC_ACCEPTED = 202,
 
     PJSIP_SC_MULTIPLE_CHOICES = 300,
@@ -400,4 +401,5 @@
     PJSIP_SC_BAD_EXTENSION = 420,
     PJSIP_SC_EXTENSION_REQUIRED = 421,
+    PJSIP_SC_SESSION_TIMER_TOO_SMALL = 422,
     PJSIP_SC_INTERVAL_TOO_BRIEF = 423,
     PJSIP_SC_TEMPORARILY_UNAVAILABLE = 480,
@@ -410,4 +412,6 @@
     PJSIP_SC_REQUEST_TERMINATED = 487,
     PJSIP_SC_NOT_ACCEPTABLE_HERE = 488,
+    PJSIP_SC_UNKNOWN_EVENT = 489,
+    PJSIP_SC_REQUEST_UPDATED = 490,
     PJSIP_SC_REQUEST_PENDING = 491,
     PJSIP_SC_UNDECIPHERABLE = 493,
@@ -420,4 +424,5 @@
     PJSIP_SC_VERSION_NOT_SUPPORTED = 505,
     PJSIP_SC_MESSAGE_TOO_LARGE = 513,
+    PJSIP_SC_PRECONDITION_FAILURE = 580,
 
     PJSIP_SC_BUSY_EVERYWHERE = 600,
@@ -427,5 +432,5 @@
 
     PJSIP_SC_TSX_TIMEOUT = 701,
-    PJSIP_SC_TSX_RESOLVE_ERROR = 702,
+    //PJSIP_SC_TSX_RESOLVE_ERROR = 702,
     PJSIP_SC_TSX_TRANSPORT_ERROR = 703,
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_transaction.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 108)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 109)
@@ -93,4 +93,5 @@
      */
     pjsip_transport	       *transport;      /**< Transport to use.      */
+    pj_bool_t			is_reliable;	/**< Transport is reliable. */
     pj_sockaddr			addr;		/**< Destination address.   */
     int				addr_len;	/**< Address length.	    */
@@ -190,9 +191,14 @@
 /**
  * Transmit message in tdata with this transaction. It is possible to
- * pass NULL in tdata for UAC transaction, which in this case the request
- * message which was specified in #pjsip_tsx_create_uac() will be sent.
+ * pass NULL in tdata for UAC transaction, which in this case the last message
+ * or the request message which was specified in #pjsip_tsx_create_uac() 
+ * will be sent.
+ *
+ * This function decrements the reference counter of the transmit buffer.
  *
  * @param tsx       The transaction.
- * @param tdata     The outgoing message.
+ * @param tdata     The outgoing message. If NULL is specified, then the
+ *		    last message transmitted (or the message specified 
+ *		    in UAC initialization) will be sent.
  *
  * @return	    PJ_SUCCESS if successfull.
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 108)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 109)
@@ -110,4 +110,13 @@
 pjsip_transport_get_default_port_for_type(pjsip_transport_type_e type);
 
+/**
+ * Get transport type name.
+ *
+ * @param t	    Transport type.
+ *
+ * @return	    Transport name.
+ */
+PJ_DECL(const char*) pjsip_transport_get_type_name(pjsip_transport_type_e t);
+
 
 /*****************************************************************************
@@ -203,4 +212,9 @@
 	/** The parsed message, if any. */
 	pjsip_msg		*msg;
+
+	/** Short description about the message. 
+	 *  Application should use #pjsip_rx_data_get_info() instead.
+	 */
+	char			*info;
 
 	/** The Call-ID header as found in the message. */
@@ -259,4 +273,13 @@
 
 };
+
+/**
+ * Get printable information about the message in the rdata.
+ *
+ * @param rdata	    The receive data buffer.
+ *
+ * @return	    Printable information.
+ */
+PJ_DECL(char*) pjsip_rx_data_get_info(pjsip_rx_data *rdata);
 
 
@@ -304,4 +327,10 @@
     char		 obj_name[PJ_MAX_OBJ_NAME];
 
+    /** Short information describing this buffer and the message in it. 
+     *  Application should use #pjsip_tx_data_get_info() instead of
+     *  directly accessing this member.
+     */
+    char		*info;
+
     /** For response message, this contains the reference to timestamp when 
      *  the original request message was received. The value of this field
@@ -340,4 +369,16 @@
     void		*token;
     void	       (*cb)(void*, pjsip_tx_data*, pj_ssize_t);
+
+    /** Transport information, only valid during on_tx_request() and 
+     *  on_tx_response() callback.
+     */
+    struct
+    {
+	pjsip_transport	    *transport;	    /**< Transport being used.	*/
+	pj_sockaddr	     dst_addr;	    /**< Destination address.	*/
+	int		     dst_addr_len;  /**< Length of address.	*/
+	char		     dst_name[16];  /**< Destination address.	*/
+	int		     dst_port;	    /**< Destination port.	*/
+    } tp_info;
 };
 
@@ -397,4 +438,14 @@
  */
 PJ_DECL(void) pjsip_tx_data_invalidate_msg( pjsip_tx_data *tdata );
+
+/**
+ * Get short printable info about the transmit data. This will normally return
+ * short information about the message.
+ *
+ * @param tdata	    The transmit buffer.
+ *
+ * @return	    Null terminated info string.
+ */
+PJ_DECL(char*) pjsip_tx_data_get_info( pjsip_tx_data *tdata );
 
 
@@ -594,5 +645,7 @@
  * @param pool	    Pool.
  * @param endpt	    Endpoint instance.
- * @param cb	    Callback to receive incoming message.
+ * @param rx_cb	    Callback to receive incoming message.
+ * @param tx_cb	    Callback to be called before transport manager is sending
+ *		    outgoing message.
  * @param p_mgr	    Pointer to receive the new transport manager.
  *
@@ -601,7 +654,9 @@
 PJ_DECL(pj_status_t) pjsip_tpmgr_create( pj_pool_t *pool,
 					 pjsip_endpoint * endpt,
-					 void (*cb)(pjsip_endpoint*,
-						    pj_status_t,
-						    pjsip_rx_data *),
+					 void (*rx_cb)(pjsip_endpoint*,
+						       pj_status_t,
+						       pjsip_rx_data *),
+					 pj_status_t (*tx_cb)(pjsip_endpoint*,
+							      pjsip_tx_data*),
 					 pjsip_tpmgr **p_mgr);
 
Index: pjproject/trunk/pjsip/include/pjsip/sip_transport_loop.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transport_loop.h	(revision 108)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transport_loop.h	(revision 109)
@@ -59,7 +59,8 @@
  *
  * @param tp		The loop transport.
- * @param fail_flag	If set to 1, the transport will return immediate error.
- *			If set to 2, the transport will return error via
- *			callback. If zero, the transport will deliver
+ * @param fail_flag	If set to 1, the transport will return fail to deliver
+ *			the message. If delay is zero, failure will occur
+ *			immediately; otherwise it will be reported in callback.
+ *			If set to zero, the transport will successfully deliver
  *			the packet.
  * @param prev_value	Optional argument to receive previous value of
@@ -74,5 +75,6 @@
 
 /**
- * Set delay (in miliseconds) before packet is delivered. This will also 
+ * Set delay (in miliseconds) before packet is received by the other end
+ * of the loop transport. This will also 
  * control the delay for error notification callback.
  *
@@ -84,7 +86,36 @@
  * @return		PJ_SUCCESS on success.
  */
+PJ_DECL(pj_status_t) pjsip_loop_set_recv_delay( pjsip_transport *tp,
+						unsigned delay,
+						unsigned *prev_value);
+
+
+/**
+ * Set delay (in miliseconds) before send notification is delivered to sender.
+ * This will also control the delay for error notification callback.
+ *
+ * @param tp		The loop transport.
+ * @param delay		Delay, in miliseconds.
+ * @param prev_value	Optional argument to receive previous value of the
+ *			delay.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjsip_loop_set_send_callback_delay( pjsip_transport *tp,
+							 unsigned delay,
+							 unsigned *prev_value);
+
+
+/**
+ * Set both receive and send notification delay.
+ *
+ * @param tp		The loop transport.
+ * @param delay		Delay, in miliseconds.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
 PJ_DECL(pj_status_t) pjsip_loop_set_delay( pjsip_transport *tp,
-					   unsigned delay,
-					   unsigned *prev_value);
+					   unsigned delay );
+
 
 PJ_END_DECL
Index: pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 108)
+++ pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 109)
@@ -36,5 +36,5 @@
 
 #define PJSIP_EX_NO_MEMORY  PJ_NO_MEMORY_EXCEPTION
-#define THIS_FILE	    "endpoint"
+#define THIS_FILE	    "sip_endpoint.c"
 
 #define MAX_METHODS   32
@@ -99,6 +99,8 @@
  * Prototypes.
  */
-static void endpt_transport_callback(pjsip_endpoint*, 
-				     pj_status_t, pjsip_rx_data*);
+static void endpt_on_rx_msg( pjsip_endpoint*, 
+			     pj_status_t, pjsip_rx_data*);
+static pj_status_t endpt_on_tx_msg( pjsip_endpoint *endpt,
+				    pjsip_tx_data *tdata );
 
 /* Defined in sip_parser.c */
@@ -230,4 +232,7 @@
     pj_list_erase(mod);
 
+    /* Set module Id to -1. */
+    mod->id = -1;
+
     /* Done. */
     status = PJ_SUCCESS;
@@ -313,5 +318,5 @@
     pj_lock_t *lock = NULL;
 
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create()"));
+    PJ_LOG(5, (THIS_FILE, "Creating endpoint instance..."));
 
     *p_endpt = NULL;
@@ -383,5 +388,6 @@
     /* Create transport manager. */
     status = pjsip_tpmgr_create( endpt->pool, endpt,
-			         &endpt_transport_callback,
+			         &endpt_on_rx_msg,
+				 &endpt_on_tx_msg,
 				 &endpt->transport_mgr);
     if (status != PJ_SUCCESS) {
@@ -392,5 +398,5 @@
     endpt->resolver = pjsip_resolver_create(endpt->pool);
     if (!endpt->resolver) {
-	PJ_LOG(4, (THIS_FILE, "pjsip_endpt_init(): error creating resolver"));
+	PJ_LOG(4, (THIS_FILE, "Error creating resolver instance"));
 	goto on_error;
     }
@@ -426,5 +432,5 @@
     pj_pool_release( endpt->pool );
 
-    PJ_LOG(4, (THIS_FILE, "pjsip_endpt_init() failed"));
+    PJ_LOG(4, (THIS_FILE, "Error creating endpoint"));
     return status;
 }
@@ -435,5 +441,12 @@
 PJ_DEF(void) pjsip_endpt_destroy(pjsip_endpoint *endpt)
 {
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_destroy()"));
+    pjsip_module *mod;
+
+    PJ_LOG(5, (THIS_FILE, "Destroying endpoing instance.."));
+
+    /* Unregister modules. */
+    while ((mod=endpt->module_list.prev) != &endpt->module_list) {
+	pjsip_endpt_unregister_module(endpt, mod);
+    }
 
     /* Shutdown and destroy all transports. */
@@ -445,4 +458,6 @@
     /* Finally destroy pool. */
     pj_pool_release(endpt->pool);
+
+    PJ_LOG(4, (THIS_FILE, "Endpoint %p destroyed", endpt));
 }
 
@@ -466,6 +481,4 @@
     pj_pool_t *pool;
 
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create_pool()"));
-
     /* Lock endpoint mutex. */
     pj_mutex_lock(endpt->mutex);
@@ -478,7 +491,5 @@
     pj_mutex_unlock(endpt->mutex);
 
-    if (pool) {
-	PJ_LOG(5, (THIS_FILE, "   pool %s created", pj_pool_getobjname(pool)));
-    } else {
+    if (!pool) {
 	PJ_LOG(4, (THIS_FILE, "Unable to create pool %s!", pool_name));
     }
@@ -493,5 +504,5 @@
 PJ_DEF(void) pjsip_endpt_release_pool( pjsip_endpoint *endpt, pj_pool_t *pool )
 {
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_release_pool(%s)", pj_pool_getobjname(pool)));
+    PJ_LOG(6, (THIS_FILE, "Releasing pool %s", pj_pool_getobjname(pool)));
 
     pj_mutex_lock(endpt->mutex);
@@ -509,5 +520,5 @@
     pj_time_val timeout = { 0, 0};
 
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_handle_events()"));
+    PJ_LOG(6, (THIS_FILE, "pjsip_endpt_handle_events()"));
 
     /* Poll the timer. The timer heap has its own mutex for better 
@@ -535,5 +546,5 @@
 						const pj_time_val *delay )
 {
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_schedule_timer(entry=%p, delay=%u.%u)",
+    PJ_LOG(6, (THIS_FILE, "pjsip_endpt_schedule_timer(entry=%p, delay=%u.%u)",
 			 entry, delay->sec, delay->msec));
     return pj_timer_heap_schedule( endpt->timer_heap, entry, delay );
@@ -546,5 +557,5 @@
 				       pj_timer_entry *entry )
 {
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_cancel_timer(entry=%p)", entry));
+    PJ_LOG(6, (THIS_FILE, "pjsip_endpt_cancel_timer(entry=%p)", entry));
     pj_timer_heap_cancel( endpt->timer_heap, entry );
 }
@@ -554,11 +565,9 @@
  * receives a message from the network.
  */
-static void endpt_transport_callback( pjsip_endpoint *endpt,
+static void endpt_on_rx_msg( pjsip_endpoint *endpt,
 				      pj_status_t status,
 				      pjsip_rx_data *rdata )
 {
     pjsip_msg *msg = rdata->msg_info.msg;
-
-    PJ_LOG(5, (THIS_FILE, "endpt_transport_callback(rdata=%p)", rdata));
 
     if (status != PJ_SUCCESS) {
@@ -572,4 +581,7 @@
 	return;
     }
+
+    PJ_LOG(5, (THIS_FILE, "Processing incoming message: %s", 
+	       pjsip_rx_data_get_info(rdata)));
 
     /* For response, check that the value in Via sent-by match the transport.
@@ -601,8 +613,9 @@
 		mismatch = PJ_TRUE;
 	    else {
-		PJ_LOG(4,(THIS_FILE, "Response %p from %s has mismatch port in "
+		PJ_LOG(4,(THIS_FILE, "Message %s from %s has mismatch port in "
 				     "sent-by but the rport parameter is "
 				     "correct",
-				     rdata, rdata->pkt_info.src_name));
+				     pjsip_rx_data_get_info(rdata), 
+				     rdata->pkt_info.src_name));
 	    }
 	}
@@ -610,6 +623,7 @@
 	if (mismatch) {
 	    PJ_TODO(ENDPT_REPORT_WHEN_DROPPING_MESSAGE);
-	    PJ_LOG(4,(THIS_FILE, "Dropping response from %s:%d because sent-by"
-				 " is mismatch", 
+	    PJ_LOG(4,(THIS_FILE, "Dropping response %s from %s:%d because "
+				 "sent-by is mismatch", 
+				 pjsip_rx_data_get_info(rdata),
 				 rdata->pkt_info.src_name, 
 				 rdata->pkt_info.src_port));
@@ -619,5 +633,5 @@
 
 
-    /* Distribute to modules. */
+    /* Distribute to modules, starting from modules with highest priority */
     pj_rwmutex_lock_read(endpt->mod_mutex);
 
@@ -638,6 +652,9 @@
 	if (!handled) {
 	    PJ_TODO(ENDPT_RESPOND_UNHANDLED_REQUEST);
-	    PJ_LOG(4,(THIS_FILE, "Request from %s:%d was dropped/unhandled by"
-				 " any modules"));
+	    PJ_LOG(4,(THIS_FILE, "Message %s from %s:%d was dropped/unhandled by"
+				 " any modules",
+				 pjsip_rx_data_get_info(rdata),
+				 rdata->pkt_info.src_name,
+				 rdata->pkt_info.src_port));
 	}
 
@@ -656,6 +673,9 @@
 
 	if (!handled) {
-	    PJ_LOG(4,(THIS_FILE, "Response from %s:%d was dropped/unhandled by"
-				 " any modules"));
+	    PJ_LOG(4,(THIS_FILE, "Message %s from %s:%d was dropped/unhandled"
+				 " by any modules",
+				 pjsip_rx_data_get_info(rdata),
+				 rdata->pkt_info.src_name,
+				 rdata->pkt_info.src_port));
 	}
     }
@@ -663,4 +683,43 @@
     pj_rwmutex_unlock_read(endpt->mod_mutex);
 }
+
+/*
+ * This callback is called by transport manager before message is sent.
+ * Modules may inspect the message before it's actually sent.
+ */
+static pj_status_t endpt_on_tx_msg( pjsip_endpoint *endpt,
+				    pjsip_tx_data *tdata )
+{
+    pj_status_t status = PJ_SUCCESS;
+    pjsip_module *mod;
+
+    /* Distribute to modules, starting from modules with LOWEST priority */
+    pj_rwmutex_lock_read(endpt->mod_mutex);
+
+    mod = endpt->module_list.prev;
+    if (tdata->msg->type == PJSIP_REQUEST_MSG) {
+	while (mod != &endpt->module_list) {
+	    if (mod->on_tx_request)
+		status = (*mod->on_tx_request)(tdata);
+	    if (status != PJ_SUCCESS)
+		break;
+	    mod = mod->prev;
+	}
+
+    } else {
+	while (mod != &endpt->module_list) {
+	    if (mod->on_tx_response)
+		status = (*mod->on_tx_response)(tdata);
+	    if (status != PJ_SUCCESS)
+		break;
+	    mod = mod->prev;
+	}
+    }
+
+    pj_rwmutex_unlock_read(endpt->mod_mutex);
+
+    return status;
+}
+
 
 /*
@@ -670,5 +729,4 @@
 					       pjsip_tx_data **p_tdata)
 {
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create_tdata()"));
     return pjsip_tx_data_create(endpt->transport_mgr, p_tdata);
 }
@@ -683,5 +741,4 @@
 				  pjsip_resolver_callback *cb)
 {
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_resolve()"));
     pjsip_resolve( endpt->resolver, pool, target, token, cb);
 }
@@ -712,5 +769,4 @@
 						  pjsip_transport **transport)
 {
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_acquire_transport()"));
     return pjsip_tpmgr_acquire_transport(endpt->transport_mgr, type, 
 					 remote, addr_len, transport);
Index: pjproject/trunk/pjsip/src/pjsip/sip_errno.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_errno.c	(revision 108)
+++ pjproject/trunk/pjsip/src/pjsip/sip_errno.c	(revision 109)
@@ -34,4 +34,5 @@
     { PJSIP_EBUSY,		"Object is busy" },
     { PJSIP_ETYPEEXISTS ,	"Object with the same type exists" },
+    { PJSIP_ESHUTDOWN,		"SIP stack shutting down" },
 
     /* Messaging errors */
Index: pjproject/trunk/pjsip/src/pjsip/sip_msg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 108)
+++ pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 109)
@@ -118,4 +118,5 @@
 
     pj_strset2( &status_phrase[200], "OK");
+    pj_strset2( &status_phrase[202], "Accepted");
 
     pj_strset2( &status_phrase[300], "Multiple Choices");
@@ -141,4 +142,5 @@
     pj_strset2( &status_phrase[420], "Bad Extension");
     pj_strset2( &status_phrase[421], "Extension Required");
+    pj_strset2( &status_phrase[422], "Session Timer Too Small");
     pj_strset2( &status_phrase[423], "Interval Too Brief");
     pj_strset2( &status_phrase[480], "Temporarily Unavailable");
@@ -151,4 +153,6 @@
     pj_strset2( &status_phrase[487], "Request Terminated");
     pj_strset2( &status_phrase[488], "Not Acceptable Here");
+    pj_strset2( &status_phrase[489], "Unknown Event");
+    pj_strset2( &status_phrase[490], "Request Updated");
     pj_strset2( &status_phrase[491], "Request Pending");
     pj_strset2( &status_phrase[493], "Undecipherable");
@@ -161,4 +165,5 @@
     pj_strset2( &status_phrase[505], "Version Not Supported");
     pj_strset2( &status_phrase[513], "Message Too Large");
+    pj_strset2( &status_phrase[580], "Precondition Failure");
 
     pj_strset2( &status_phrase[600], "Busy Everywhere");
Index: pjproject/trunk/pjsip/src/pjsip/sip_resolve.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_resolve.c	(revision 108)
+++ pjproject/trunk/pjsip/src/pjsip/sip_resolve.c	(revision 109)
@@ -19,7 +19,11 @@
 #include <pjsip/sip_resolve.h>
 #include <pjsip/sip_transport.h>
+#include <pjsip/sip_errno.h>
 #include <pj/pool.h>
 #include <pj/ctype.h>
 #include <pj/assert.h>
+#include <pj/log.h>
+
+#define THIS_FILE   "sip_resolve.c"
 
 struct pjsip_resolver_t
@@ -68,4 +72,10 @@
     PJ_UNUSED_ARG(resolver);
     PJ_UNUSED_ARG(pool);
+
+    PJ_LOG(5,(THIS_FILE, "Resolving server '%.*s:%d' type=%s",
+			 target->addr.host.slen,
+			 target->addr.host.ptr,
+			 target->addr.port,
+			 pjsip_transport_get_type_name(type)));
 
     /* We only do synchronous resolving at this moment. */
@@ -117,8 +127,28 @@
 				      &target->addr.host, 
 				     (pj_uint16_t)target->addr.port);
-	pj_assert(status == PJ_SUCCESS);
+    }
+
+    if (status != PJ_SUCCESS) {
+	char errmsg[PJSIP_ERR_MSG_SIZE];
+	PJ_LOG(4,(THIS_FILE, "Failed to resolve '%.*s'. Err=%d (%s)",
+			     target->addr.host.slen,
+			     target->addr.host.ptr,
+			     status,
+			     pjsip_strerror(status,errmsg,sizeof(errmsg)).ptr));
+	(*cb)(status, token, &svr_addr);
+	return;
     }
 
     /* Call the callback. */
+    PJ_LOG(5,(THIS_FILE, "Server resolved: '%.*s:%d' type=%s has %d entries, "
+			 "entry[0]=%s:%d type=%s",
+			 target->addr.host.slen,
+			 target->addr.host.ptr,
+			 target->addr.port,
+			 pjsip_transport_get_type_name(type),
+			 1,
+			 pj_inet_ntoa(((pj_sockaddr_in*)&svr_addr.entry[0].addr)->sin_addr),
+			 target->addr.port,
+			 pjsip_transport_get_type_name(type)));
     svr_addr.count = (status == PJ_SUCCESS) ? 1 : 0;
     svr_addr.entry[0].type = type;
